/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VIsDepartmentRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VIsDepartment extends TableImpl<VIsDepartmentRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_is_department</code>
     */
    public static final VIsDepartment V_IS_DEPARTMENT = new VIsDepartment();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VIsDepartmentRecord> getRecordType() {
        return VIsDepartmentRecord.class;
    }

    /**
     * The column <code>common_dd.v_is_department.key_element</code>.
     */
    public final TableField<VIsDepartmentRecord, Integer> KEY_ELEMENT = createField(DSL.name("key_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_is_department.dn</code>.
     */
    public final TableField<VIsDepartmentRecord, String> DN = createField(DSL.name("dn"), SQLDataType.CLOB, this, "");

    private VIsDepartment(Name alias, Table<VIsDepartmentRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VIsDepartment(Name alias, Table<VIsDepartmentRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
         create view "v_is_department" as  SELECT t_core_element_hierarchy.key_element,
            t_core_element_hierarchy.dn
           FROM common_dd.t_core_element_hierarchy
          WHERE (t_core_element_hierarchy.key_parent_element IN ( SELECT v_is_study.key_element
                   FROM common_dd.v_is_study
                UNION ALL
                 SELECT v_is_studygroup.key_element
                   FROM common_dd.v_is_studygroup))
        EXCEPT
         SELECT v_is_variable.key_element,
            v_is_variable.dn
           FROM common_dd.v_is_variable
        EXCEPT
         SELECT v_is_form.key_element,
            v_is_form.dn
           FROM common_dd.v_is_form
        EXCEPT
         SELECT v_is_study.key_element,
            v_is_study.dn
           FROM common_dd.v_is_study
        EXCEPT
         SELECT v_is_studygroup.key_element,
            v_is_studygroup.dn
           FROM common_dd.v_is_studygroup;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_is_department</code> table reference
     */
    public VIsDepartment(String alias) {
        this(DSL.name(alias), V_IS_DEPARTMENT);
    }

    /**
     * Create an aliased <code>common_dd.v_is_department</code> table reference
     */
    public VIsDepartment(Name alias) {
        this(alias, V_IS_DEPARTMENT);
    }

    /**
     * Create a <code>common_dd.v_is_department</code> table reference
     */
    public VIsDepartment() {
        this(DSL.name("v_is_department"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VIsDepartment as(String alias) {
        return new VIsDepartment(DSL.name(alias), this);
    }

    @Override
    public VIsDepartment as(Name alias) {
        return new VIsDepartment(alias, this);
    }

    @Override
    public VIsDepartment as(Table<?> alias) {
        return new VIsDepartment(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VIsDepartment rename(String name) {
        return new VIsDepartment(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VIsDepartment rename(Name name) {
        return new VIsDepartment(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VIsDepartment rename(Table<?> name) {
        return new VIsDepartment(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsDepartment where(Condition condition) {
        return new VIsDepartment(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsDepartment where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsDepartment where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsDepartment where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VIsDepartment where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VIsDepartment where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VIsDepartment where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VIsDepartment where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsDepartment whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsDepartment whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
